diff --git a/src/iotjs_magic_strings.h b/src/iotjs_magic_strings.h
index e83a689d0..f21e35c85 100644
--- a/src/iotjs_magic_strings.h
+++ b/src/iotjs_magic_strings.h
@@ -289,8 +289,8 @@
 #define IOTJS_MAGIC_STRING_TOHEXSTRING "toHexString"
 #define IOTJS_MAGIC_STRING_TOSTRING "toString"
 #if ENABLE_MODULE_SPI
-#define IOTJS_MAGIC_STRING_TRANSFERARRAY "transferArray"
-#define IOTJS_MAGIC_STRING_TRANSFERBUFFER "transferBuffer"
+#define IOTJS_MAGIC_STRING_TRANSFER "transfer"
+#define IOTJS_MAGIC_STRING_TRANSFERSYNC "transferSync"
 #endif
 #define IOTJS_MAGIC_STRING_UNLINK "unlink"
 #define IOTJS_MAGIC_STRING_UNREF "unref"
diff --git a/src/js/spi.js b/src/js/spi.js
index 0a8f2a286..cbbff4a26 100644
--- a/src/js/spi.js
+++ b/src/js/spi.js
@@ -13,212 +13,19 @@
  * limitations under the License.
  */
 
-var util = require('util');
-var spi = native;
-
-var defaultConfiguration = {
-  mode: spi.MODE[0],
-  chipSelect: spi.CHIPSELECT.NONE,
-  maxSpeed: 500000,
-  bitsPerWord: 8,
-  bitOrder: spi.BITORDER.MSB,
-  loopback: false,
-};
-
-
-function Spi() {
-  if (!(this instanceof Spi)) {
-    return new Spi();
-  }
-}
-
-Spi.prototype.open = function(configuration, callback) {
-  return spiBusOpen(configuration, callback);
-};
-
-Spi.prototype.MODE = spi.MODE;
-Spi.prototype.CHIPSELECT = spi.CHIPSELECT;
-Spi.prototype.BITORDER = spi.BITORDER;
-
-
-function spiBusOpen(configuration, callback) {
-  var _binding = null;
-
-  function SpiBus(configuration, callback) {
-    var self = this;
-
-    if (process.platform === 'linux') {
-      if (!util.isString(configuration.device)) {
-        throw new TypeError('Bad configuration - device: String');
-      }
-    } else if (process.platform === 'nuttx') {
-      if (!util.isNumber(configuration.bus)) {
-        throw new TypeError('Bad configuration - bus: Number');
-      }
-    }
-
-    // validate mode
-    var mode = configuration.mode;
-    if (mode !== undefined) {
-      if (mode !== spi.MODE[0] && mode !== spi.MODE[1] &&
-          mode !== spi.MODE[2] && mode !== spi.MODE[3]) {
-        throw new TypeError(
-          'Bad arguments - mode should be MODE[0], [1], [2] or [3]');
-      }
-    } else {
-      configuration.mode = defaultConfiguration.mode;
-    }
-
-    // validate chip-select
-    var chipSelect = configuration.chipSelect;
-    if (chipSelect !== undefined) {
-      if (chipSelect != spi.CHIPSELECT.NONE &&
-          chipSelect != spi.CHIPSELECT.HIGH) {
-        throw new TypeError(
-          'Bad arguments - chipSelect should be CHIPSELECT.NONE or HIGH');
-      }
-    } else {
-      configuration.chipSelect = defaultConfiguration.chipSelect;
-    }
-
-    // validate max speed
-    if (configuration.maxSpeed !== undefined) {
-      if (!util.isNumber(configuration.maxSpeed)) {
-        throw new TypeError('Bad arguments - maxSpeed should be Number');
-      }
-    } else {
-      configuration.maxSpeed = defaultConfiguration.maxSpeed;
-    }
-
-    // validate bits per word
-    var bitsPerWord = configuration.bitsPerWord;
-    if (bitsPerWord !== undefined) {
-      if (bitsPerWord != 8 && bitsPerWord != 9) {
-        throw new TypeError('Bad arguments - bitsPerWord should be 8 or 9');
-      }
-    } else {
-      configuration.bitsPerWord = defaultConfiguration.bitsPerWord;
-    }
-
-    // validate bit order
-    var bitOrder = configuration.bitOrder;
-    if (bitOrder !== undefined) {
-      if (bitOrder != spi.BITORDER.MSB && bitOrder != spi.BITORDER.LSB) {
-        throw new TypeError(
-          'Bad arguments - bitOrder should be BITORDER.MSB or LSB');
-      }
-    } else {
-      configuration.bitOrder = defaultConfiguration.bitOrder;
-    }
-
-    // validate loopback
-    var loopback = configuration.loopback;
-    if (loopback !== undefined) {
-      if (!util.isBoolean(loopback)) {
-        throw new TypeError('Bad arguments - loopback should be Boolean');
-      }
-    } else {
-      configuration.loopback = defaultConfiguration.loopback;
-    }
-
-    _binding = new spi.Spi(configuration, function(err) {
-      util.isFunction(callback) && callback.call(self, err);
-    });
-
-    process.on('exit', (function(self) {
-    return function() {
-      if (_binding !== null) {
-        self.closeSync();
-      }
-    };
-    })(this));
-  }
-
-  SpiBus.prototype.transfer = function(txBuffer, rxBuffer, callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('SPI bus is not opened');
-    }
-
-    if (txBuffer.length === undefined || rxBuffer.length === undefined
-        || txBuffer.length <= 0 || rxBuffer.length <= 0
-        || txBuffer.length != rxBuffer.length) {
-      throw new Error('Bad arguments - buffer length');
-    }
-
-    var rxLength = rxBuffer.length;
-    var afterCallback = function(err, buffer) {
-      for (var i = 0; i < rxLength; i++) {
-        rxBuffer[i] = buffer[i];
-      }
-
-      util.isFunction(callback) && callback.call(self, err);
-    };
-
-    if (util.isArray(txBuffer) && util.isArray(rxBuffer)) {
-      _binding.transferArray(txBuffer, rxBuffer, afterCallback);
-    } else if (util.isBuffer(txBuffer) && util.isBuffer(rxBuffer)) {
-      _binding.transferBuffer(txBuffer, rxBuffer, afterCallback);
-    } else {
-      throw new TypeError('Bad arguments - buffer should be Array or Buffer');
-    }
-  };
-
-  SpiBus.prototype.transferSync = function(txBuffer, rxBuffer) {
-    if (_binding === null) {
-      throw new Error('SPI bus is not opened');
-    }
-
-    if (txBuffer.length === undefined || rxBuffer.length === undefined
-      || txBuffer.length <= 0 || rxBuffer.length <= 0
-      || txBuffer.length != rxBuffer.length) {
-      throw new Error('Bad arguments - buffer length');
-    }
-
-    var data = null;
-    if (util.isArray(txBuffer) && util.isArray(rxBuffer)) {
-      data = _binding.transferArray(txBuffer, rxBuffer);
-    } else if (util.isBuffer(txBuffer) && util.isBuffer(rxBuffer)) {
-      data = _binding.transferBuffer(txBuffer, rxBuffer);
-    } else {
-      throw new TypeError('Bad arguments - buffer should be Array or Buffer');
-    }
-
-    if (data !== null && (util.isArray(data) || util.isBuffer(data)) &&
-      data.length === rxBuffer.length) {
-      for (var i = 0; i < rxBuffer.length; i++) {
-        rxBuffer[i] = data[i];
-      }
-    } else {
-      throw new Error('Spi Transfer Error');
-    }
-  };
-
-  SpiBus.prototype.close = function(callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('SPI bus is not opened');
-    }
-
-    _binding.close(function(err) {
-      util.isFunction(callback) && callback.call(self, err);
-      _binding = null;
+var spi = {
+  open: function(config, callback) {
+    var spiBus = new native(config, function(err) {
+      callback(err, spiBus);
     });
-  };
-
-  SpiBus.prototype.closeSync = function() {
-    if (_binding === null) {
-      throw new Error('SPI bus is not opened');
-    }
-
-    _binding.close();
-    _binding = null;
-  };
-
-  return new SpiBus(configuration, callback);
-}
-
+    return spiBus;
+  },
+  openSync: function(config) {
+    return new native(config);
+  },
+  MODE: native.MODE,
+  CHIPSELECT: native.CHIPSELECT,
+  BITORDER: native.BITORDER
+};
 
-module.exports = Spi;
+module.exports = spi;
diff --git a/src/modules/iotjs_module_spi.c b/src/modules/iotjs_module_spi.c
index 7abadaf92..801d16444 100644
--- a/src/modules/iotjs_module_spi.c
+++ b/src/modules/iotjs_module_spi.c
@@ -19,96 +19,75 @@
 #include <unistd.h>
 
 
+#define SPI_TX_ARRAY_BIT 1u
+
 IOTJS_DEFINE_NATIVE_HANDLE_INFO_THIS_MODULE(spi);
 
-static iotjs_spi_t* iotjs_spi_create(jerry_value_t jspi) {
+static iotjs_spi_t* spi_create(jerry_value_t jspi) {
   iotjs_spi_t* spi = IOTJS_ALLOC(iotjs_spi_t);
   IOTJS_VALIDATED_STRUCT_CONSTRUCTOR(iotjs_spi_t, spi);
+  iotjs_spi_create_platform_data(spi);
   _this->jobject = jspi;
   jerry_set_object_native_pointer(jspi, spi, &this_module_native_info);
 
-#if defined(__linux__)
-  _this->device = iotjs_string_create("");
-#endif
-
   return spi;
 }
 
-
-static void iotjs_spi_destroy(iotjs_spi_t* spi) {
-#if defined(__linux__)
-  IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_spi_t, spi);
-  iotjs_string_destroy(&_this->device);
-#endif
-
-  IOTJS_RELEASE(spi);
-}
-
-
-#define THIS iotjs_spi_reqwrap_t* spi_reqwrap
-
-
-static iotjs_spi_reqwrap_t* iotjs_spi_reqwrap_create(jerry_value_t jcallback,
-                                                     iotjs_spi_t* spi,
-                                                     SpiOp op) {
+static iotjs_spi_reqwrap_t* spi_reqwrap_create(jerry_value_t jcallback,
+                                               iotjs_spi_t* spi, SpiOp op) {
   iotjs_spi_reqwrap_t* spi_reqwrap = IOTJS_ALLOC(iotjs_spi_reqwrap_t);
   IOTJS_VALIDATED_STRUCT_CONSTRUCTOR(iotjs_spi_reqwrap_t, spi_reqwrap);
 
   iotjs_reqwrap_initialize(&_this->reqwrap, jcallback, (uv_req_t*)&_this->req);
 
   _this->req_data.op = op;
-  _this->spi_instance = spi;
+  _this->spi_data = spi;
 
   return spi_reqwrap;
 }
 
-
-static void iotjs_spi_reqwrap_destroy(THIS) {
+static void spi_reqwrap_destroy(iotjs_spi_reqwrap_t* spi_reqwrap) {
   IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_spi_reqwrap_t, spi_reqwrap);
   iotjs_reqwrap_destroy(&_this->reqwrap);
   IOTJS_RELEASE(spi_reqwrap);
 }
 
-
-static void iotjs_spi_reqwrap_dispatched(THIS) {
+static void spi_reqwrap_dispatched(iotjs_spi_reqwrap_t* spi_reqwrap) {
   IOTJS_VALIDATABLE_STRUCT_METHOD_VALIDATE(iotjs_spi_reqwrap_t, spi_reqwrap);
-  iotjs_spi_reqwrap_destroy(spi_reqwrap);
+  spi_reqwrap_destroy(spi_reqwrap);
 }
 
-
-static uv_work_t* iotjs_spi_reqwrap_req(THIS) {
+static uv_work_t* spi_reqwrap_req(iotjs_spi_reqwrap_t* spi_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_reqwrap_t, spi_reqwrap);
   return &_this->req;
 }
 
-
-static jerry_value_t iotjs_spi_reqwrap_jcallback(THIS) {
+static jerry_value_t spi_reqwrap_jcallback(iotjs_spi_reqwrap_t* spi_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_reqwrap_t, spi_reqwrap);
   return iotjs_reqwrap_jcallback(&_this->reqwrap);
 }
 
-
 iotjs_spi_reqwrap_t* iotjs_spi_reqwrap_from_request(uv_work_t* req) {
   return (iotjs_spi_reqwrap_t*)(iotjs_reqwrap_from_request((uv_req_t*)req));
 }
 
-
-iotjs_spi_reqdata_t* iotjs_spi_reqwrap_data(THIS) {
+iotjs_spi_reqdata_t* iotjs_spi_reqwrap_data(iotjs_spi_reqwrap_t* spi_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_reqwrap_t, spi_reqwrap);
   return &_this->req_data;
 }
 
-
-iotjs_spi_t* iotjs_spi_instance_from_reqwrap(THIS) {
+iotjs_spi_t* iotjs_spi_instance_from_reqwrap(iotjs_spi_reqwrap_t* spi_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_reqwrap_t, spi_reqwrap);
-  return _this->spi_instance;
+  return _this->spi_data;
 }
 
+static void iotjs_spi_destroy(iotjs_spi_t* spi) {
+  IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_spi_t, spi);
+  iotjs_spi_destroy_platform_data(_this->platform_data);
+  IOTJS_RELEASE(spi);
+}
 
-#undef THIS
-
-
-static int iotjs_spi_get_array_data(char** buf, jerry_value_t jarray) {
+static int spi_get_array_data(char** buf, jerry_value_t jarray) {
   jerry_value_t jlength =
       iotjs_jval_get_property(jarray, IOTJS_MAGIC_STRING_LENGTH);
   IOTJS_ASSERT(!jerry_value_is_undefined(jlength));
@@ -128,91 +107,71 @@ static int iotjs_spi_get_array_data(char** buf, jerry_value_t jarray) {
   return (int)length;
 }
 
-
-static void iotjs_spi_set_array_buffer(iotjs_spi_t* spi, jerry_value_t jtx_buf,
-                                       jerry_value_t jrx_buf) {
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
-
-  int tx_buf_len = iotjs_spi_get_array_data(&_this->tx_buf_data, jtx_buf);
-  int rx_buf_len = iotjs_spi_get_array_data(&_this->rx_buf_data, jrx_buf);
-
-  IOTJS_ASSERT(_this->tx_buf_data != NULL && _this->rx_buf_data != NULL);
-  IOTJS_ASSERT(tx_buf_len > 0 && rx_buf_len > 0 && tx_buf_len == rx_buf_len);
-
-  _this->buf_len = tx_buf_len;
-}
-
-
-static void iotjs_spi_set_buffer(iotjs_spi_t* spi, jerry_value_t jtx_buf,
-                                 jerry_value_t jrx_buf) {
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
-
-  iotjs_bufferwrap_t* tx_buf = iotjs_bufferwrap_from_jbuffer(jtx_buf);
-  iotjs_bufferwrap_t* rx_buf = iotjs_bufferwrap_from_jbuffer(jrx_buf);
-
-  _this->tx_buf_data = iotjs_bufferwrap_buffer(tx_buf);
-  uint8_t tx_buf_len = iotjs_bufferwrap_length(tx_buf);
-  _this->rx_buf_data = iotjs_bufferwrap_buffer(rx_buf);
-  uint8_t rx_buf_len = iotjs_bufferwrap_length(rx_buf);
-
-  IOTJS_ASSERT(_this->tx_buf_data != NULL && _this->rx_buf_data != NULL);
-  IOTJS_ASSERT(tx_buf_len > 0 && rx_buf_len > 0 && tx_buf_len == rx_buf_len);
-
-  _this->buf_len = tx_buf_len;
-}
-
-
-static void iotjs_spi_release_buffer(iotjs_spi_t* spi) {
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
-
-  iotjs_buffer_release(_this->tx_buf_data);
-  iotjs_buffer_release(_this->rx_buf_data);
-}
-
-
-static void iotjs_spi_set_configuration(iotjs_spi_t* spi,
-                                        jerry_value_t joptions) {
+/* Default configuration:
+ *{
+ *  mode: spi.MODE[0],
+ *  chipSelect: spi.CHIPSELECT.NONE,
+ *  maxSpeed: 500000,
+ *  bitsPerWord: 8,
+ *  bitOrder: spi.BITORDER.MSB,
+ *  loopback: false
+ * }
+ */
+static void spi_set_configuration(iotjs_spi_t* spi, jerry_value_t joptions) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
 
-#if defined(__linux__)
-  jerry_value_t jdevice =
-      iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_DEVICE);
-  _this->device = iotjs_jval_as_string(jdevice);
-  jerry_release_value(jdevice);
-#elif defined(__NUTTX__) || defined(__TIZENRT__)
-  jerry_value_t jbus =
-      iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_BUS);
-  _this->bus = iotjs_jval_as_number(jbus);
-  jerry_release_value(jbus);
-#endif
   jerry_value_t jmode =
       iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_MODE);
-  _this->mode = (SpiMode)iotjs_jval_as_number(jmode);
+  if (jerry_value_is_undefined(jmode)) {
+    _this->mode = kSpiMode_0;
+  } else {
+    _this->mode = (SpiMode)iotjs_jval_as_number(jmode);
+  }
   jerry_release_value(jmode);
 
   jerry_value_t jchip_select =
       iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_CHIPSELECT);
-  _this->chip_select = (SpiChipSelect)iotjs_jval_as_number(jchip_select);
+  if (jerry_value_is_undefined(jchip_select)) {
+    _this->chip_select = kSpiCsNone;
+  } else {
+    _this->chip_select = (SpiChipSelect)iotjs_jval_as_number(jchip_select);
+  }
   jerry_release_value(jchip_select);
 
   jerry_value_t jmax_speed =
       iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_MAXSPEED);
-  _this->max_speed = iotjs_jval_as_number(jmax_speed);
+  if (jerry_value_is_undefined(jmax_speed)) {
+    _this->max_speed = 500000;
+  } else {
+    _this->max_speed = iotjs_jval_as_number(jmax_speed);
+  }
   jerry_release_value(jmax_speed);
 
   jerry_value_t jbits_per_word =
       iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_BITSPERWORD);
-  _this->bits_per_word = (SpiOrder)iotjs_jval_as_number(jbits_per_word);
+  if (jerry_value_is_undefined(jbits_per_word)) {
+    _this->bits_per_word = 8;
+  } else {
+    _this->bits_per_word = iotjs_jval_as_number(jbits_per_word);
+  }
   jerry_release_value(jbits_per_word);
 
   jerry_value_t jbit_order =
       iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_BITORDER);
-  _this->bit_order = (SpiOrder)iotjs_jval_as_number(jbit_order);
+  if (jerry_value_is_undefined(jbit_order)) {
+    _this->bit_order = kSpiOrderMsb;
+  } else {
+    _this->bit_order = (SpiOrder)iotjs_jval_as_number(jbit_order);
+  }
   jerry_release_value(jbit_order);
 
   jerry_value_t jloopback =
       iotjs_jval_get_property(joptions, IOTJS_MAGIC_STRING_LOOPBACK);
-  _this->loopback = iotjs_jval_as_boolean(jloopback);
+  if (jerry_value_is_undefined(jloopback)) {
+    _this->loopback = false;
+  } else {
+    _this->loopback = iotjs_jval_as_boolean(jloopback);
+  }
   jerry_release_value(jloopback);
 }
 
@@ -220,77 +179,87 @@ static void iotjs_spi_set_configuration(iotjs_spi_t* spi,
 /*
  * SPI worker function
  */
-static void iotjs_spi_transfer_worker(uv_work_t* work_req) {
-  SPI_WORKER_INIT;
+static void spi_worker(uv_work_t* work_req) {
+  iotjs_spi_reqwrap_t* req_wrap = iotjs_spi_reqwrap_from_request(work_req);
+  iotjs_spi_reqdata_t* req_data = iotjs_spi_reqwrap_data(req_wrap);
+  iotjs_spi_t* spi = iotjs_spi_instance_from_reqwrap(req_wrap);
 
-  if (!iotjs_spi_transfer(spi)) {
-    req_data->result = false;
-    return;
+  switch (req_data->op) {
+    case kSpiOpClose: {
+      req_data->result = iotjs_spi_close(spi);
+      break;
+    }
+    case kSpiOpOpen: {
+      req_data->result = iotjs_spi_open(spi);
+      break;
+    }
+    case kSpiOpTransferArray:
+    case kSpiOpTransferBuffer: {
+      req_data->result = iotjs_spi_transfer(spi);
+      break;
+    }
+    default:
+      IOTJS_ASSERT(!"Invalid Operation");
   }
-
-  req_data->result = true;
 }
 
-
-static void iotjs_spi_close_worker(uv_work_t* work_req) {
-  SPI_WORKER_INIT;
-
-  if (!iotjs_spi_close(spi)) {
-    req_data->result = false;
-    return;
+static const char* spi_error_str(uint8_t op) {
+  switch (op) {
+    case kSpiOpClose:
+      return "Close error, cannot close SPI";
+    case kSpiOpOpen:
+      return "Open error, cannot open SPI";
+    case kSpiOpTransferArray:
+    case kSpiOpTransferBuffer:
+      return "Transfer error, cannot transfer from SPI device";
+    default:
+      return "Unknown error";
   }
-
-  req_data->result = true;
 }
 
-
-static void iotjs_spi_after_work(uv_work_t* work_req, int status) {
+static void spi_after_work(uv_work_t* work_req, int status) {
   iotjs_spi_reqwrap_t* req_wrap = iotjs_spi_reqwrap_from_request(work_req);
   iotjs_spi_reqdata_t* req_data = iotjs_spi_reqwrap_data(req_wrap);
-  iotjs_spi_t* spi = iotjs_spi_instance_from_reqwrap(req_wrap);
 
   iotjs_jargs_t jargs = iotjs_jargs_create(2);
 
-  bool result = req_data->result;
-
   if (status) {
     iotjs_jargs_append_error(&jargs, "System error");
   } else {
     switch (req_data->op) {
-      case kSpiOpOpen:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Failed to export SPI device");
+      case kSpiOpClose:
+      case kSpiOpOpen: {
+        if (!req_data->result) {
+          iotjs_jargs_append_error(&jargs, spi_error_str(req_data->op));
         } else {
           iotjs_jargs_append_null(&jargs);
         }
         break;
+      }
       case kSpiOpTransferArray:
-      case kSpiOpTransferBuffer:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Cannot transfer from SPI device");
+      case kSpiOpTransferBuffer: {
+        iotjs_spi_t* spi = iotjs_spi_instance_from_reqwrap(req_wrap);
+        IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+
+        if (!req_data->result) {
+          iotjs_jargs_append_error(&jargs, spi_error_str(req_data->op));
         } else {
           iotjs_jargs_append_null(&jargs);
 
-          IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
-
           // Append read data
-          jerry_value_t result_data =
+          jerry_value_t result =
               iotjs_jval_create_byte_array(_this->buf_len, _this->rx_buf_data);
-          iotjs_jargs_append_jval(&jargs, result_data);
-          jerry_release_value(result_data);
+          iotjs_jargs_append_jval(&jargs, result);
+          jerry_release_value(result);
         }
 
-        if (req_data->op == kSpiOpTransferArray)
-          iotjs_spi_release_buffer(spi);
-
-        break;
-      case kSpiOpClose:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Failed to unexport SPI device");
-        } else {
-          iotjs_jargs_append_null(&jargs);
+        if (req_data->op == kSpiOpTransferArray) {
+          iotjs_buffer_release(_this->tx_buf_data);
         }
+
+        iotjs_buffer_release(_this->rx_buf_data);
         break;
+      }
       default: {
         IOTJS_ASSERT(!"Unreachable");
         break;
@@ -298,140 +267,144 @@ static void iotjs_spi_after_work(uv_work_t* work_req, int status) {
     }
   }
 
-  jerry_value_t jcallback = iotjs_spi_reqwrap_jcallback(req_wrap);
-  iotjs_make_callback(jcallback, jerry_create_undefined(), &jargs);
+  jerry_value_t jcallback = spi_reqwrap_jcallback(req_wrap);
+  if (jerry_value_is_function(jcallback)) {
+    iotjs_make_callback(jcallback, jerry_create_undefined(), &jargs);
+  }
 
   iotjs_jargs_destroy(&jargs);
-
-  iotjs_spi_reqwrap_dispatched(req_wrap);
+  spi_reqwrap_dispatched(req_wrap);
 }
 
-
-iotjs_spi_t* iotjs_spi_get_instance(jerry_value_t jspi) {
-  uintptr_t handle = iotjs_jval_get_object_native_handle(jspi);
-  return (iotjs_spi_t*)(handle);
-}
-
-
-#define SPI_ASYNC(call, this, jcallback, op)                                   \
-  do {                                                                         \
-    uv_loop_t* loop = iotjs_environment_loop(iotjs_environment_get());         \
-    iotjs_spi_reqwrap_t* req_wrap =                                            \
-        iotjs_spi_reqwrap_create(jcallback, this, op);                         \
-    uv_work_t* req = iotjs_spi_reqwrap_req(req_wrap);                          \
-    uv_queue_work(loop, req, iotjs_spi_##call##_worker, iotjs_spi_after_work); \
+#define SPI_CALL_ASYNC(op, jcallback)                                       \
+  do {                                                                      \
+    uv_loop_t* loop = iotjs_environment_loop(iotjs_environment_get());      \
+    iotjs_spi_reqwrap_t* req_wrap = spi_reqwrap_create(jcallback, spi, op); \
+    uv_work_t* req = spi_reqwrap_req(req_wrap);                             \
+    uv_queue_work(loop, req, spi_worker, spi_after_work);                   \
   } while (0)
 
 
-JS_FUNCTION(SpiConstructor) {
+JS_FUNCTION(SpiCons) {
   DJS_CHECK_THIS();
-  DJS_CHECK_ARGS(2, object, function);
+  DJS_CHECK_ARGS(1, object);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
   // Create SPI object
   jerry_value_t jspi = JS_GET_THIS();
-  iotjs_spi_t* spi = iotjs_spi_create(jspi);
-  IOTJS_ASSERT(spi == iotjs_spi_get_instance(jspi));
+  iotjs_spi_t* spi = spi_create(jspi);
 
   // Set configuration
-  jerry_value_t jconfiguration = JS_GET_ARG(0, object);
-  iotjs_spi_set_configuration(spi, jconfiguration);
-
-  jerry_value_t jcallback = JS_GET_ARG(1, function);
-  SPI_ASYNC(open, spi, jcallback, kSpiOpOpen);
-
-  return jerry_create_undefined();
-}
+  jerry_value_t jconfig;
+  JS_GET_REQUIRED_ARG_VALUE(0, jconfig, IOTJS_MAGIC_STRING_CONFIG, object);
 
+  jerry_value_t res = iotjs_spi_set_platform_config(spi, jconfig);
+  if (jerry_value_has_error_flag(res)) {
+    return res;
+  }
 
-// FIXME: do not need transferArray if array buffer is implemented.
-JS_FUNCTION(TransferArray) {
-  JS_DECLARE_THIS_PTR(spi, spi);
+  spi_set_configuration(spi, jconfig);
 
-  DJS_CHECK_ARGS(2, array, array);
-  DJS_CHECK_ARG_IF_EXIST(2, function);
+  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(1, function);
 
-  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(2, function);
+  // If the callback doesn't exist, it is completed synchronously.
+  // Otherwise, it will be executed asynchronously.
+  if (!jerry_value_is_null(jcallback)) {
+    SPI_CALL_ASYNC(kSpiOpOpen, jcallback);
+  } else if (!iotjs_spi_open(spi)) {
+    return JS_CREATE_ERROR(COMMON, spi_error_str(kSpiOpOpen));
+  }
 
-  iotjs_spi_set_array_buffer(spi, JS_GET_ARG(0, array), JS_GET_ARG(1, array));
+  return jerry_create_undefined();
+}
 
-  jerry_value_t result = jerry_create_undefined();
-  if (!jerry_value_is_null(jcallback)) {
-    SPI_ASYNC(transfer, spi, jcallback, kSpiOpTransferArray);
-  } else {
-    if (!iotjs_spi_transfer(spi)) {
-      result = JS_CREATE_ERROR(COMMON, "SPI Transfer Error");
-    } else {
-      IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+static uint8_t spi_transfer_helper(jerry_value_t jtx_buf, iotjs_spi_t* spi) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
 
-      result = iotjs_jval_create_byte_array(_this->buf_len, _this->rx_buf_data);
-    }
+  uint8_t result;
+  if (jerry_value_is_array(jtx_buf)) {
+    _this->buf_len = spi_get_array_data(&_this->tx_buf_data, jtx_buf);
+    result = kSpiOpTransferArray;
+  } else if (jerry_value_is_object(jtx_buf)) {
+    iotjs_bufferwrap_t* tx_buf = iotjs_bufferwrap_from_jbuffer(jtx_buf);
 
-    iotjs_spi_release_buffer(spi);
+    _this->tx_buf_data = iotjs_bufferwrap_buffer(tx_buf);
+    _this->buf_len = iotjs_bufferwrap_length(tx_buf);
+    result = kSpiOpTransferBuffer;
   }
 
+  IOTJS_ASSERT(_this->buf_len > 0);
+  _this->rx_buf_data = iotjs_buffer_allocate(_this->buf_len);
+  IOTJS_ASSERT(_this->tx_buf_data != NULL && _this->rx_buf_data != NULL);
+
   return result;
 }
 
-
-JS_FUNCTION(TransferBuffer) {
+// FIXME: do not need transferArray if array buffer is implemented.
+JS_FUNCTION(Transfer) {
   JS_DECLARE_THIS_PTR(spi, spi);
-
-  DJS_CHECK_ARGS(2, object, object);
   DJS_CHECK_ARG_IF_EXIST(2, function);
 
-  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(2, function);
+  uint8_t op = spi_transfer_helper(jargv[0], spi);
+  SPI_CALL_ASYNC((SpiOp)op, JS_GET_ARG_IF_EXIST(2, function));
+
+  return jerry_create_undefined();
+}
 
-  iotjs_spi_set_buffer(spi, JS_GET_ARG(0, object), JS_GET_ARG(1, object));
+JS_FUNCTION(TransferSync) {
+  JS_DECLARE_THIS_PTR(spi, spi);
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
 
-  if (!jerry_value_is_null(jcallback)) {
-    SPI_ASYNC(transfer, spi, jcallback, kSpiOpTransferBuffer);
-    return jerry_create_undefined();
-  }
+  uint8_t op = spi_transfer_helper(jargv[0], spi);
 
+  jerry_value_t result = jerry_create_undefined();
   if (!iotjs_spi_transfer(spi)) {
-    return JS_CREATE_ERROR(COMMON, "SPI Transfer Error");
+    result = JS_CREATE_ERROR(COMMON, spi_error_str(op));
+  } else {
+    result = iotjs_jval_create_byte_array(_this->buf_len, _this->rx_buf_data);
   }
 
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
-  return iotjs_jval_create_byte_array(_this->buf_len, _this->rx_buf_data);
-}
+  if (op == kSpiOpTransferArray) {
+    iotjs_buffer_release(_this->tx_buf_data);
+  }
 
+  iotjs_buffer_release(_this->rx_buf_data);
+
+  return result;
+}
 
 JS_FUNCTION(Close) {
   JS_DECLARE_THIS_PTR(spi, spi);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
-  DJS_CHECK_ARG_IF_EXIST(0, function);
+  SPI_CALL_ASYNC(kSpiOpClose, JS_GET_ARG_IF_EXIST(0, function));
 
-  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(0, function);
+  return jerry_create_undefined();
+}
 
-  if (!jerry_value_is_null(jcallback)) {
-    SPI_ASYNC(close, spi, jcallback, kSpiOpClose);
-  } else {
-    if (!iotjs_spi_close(spi)) {
-      return JS_CREATE_ERROR(COMMON, "SPI Close Error");
-    }
+JS_FUNCTION(CloseSync) {
+  JS_DECLARE_THIS_PTR(spi, spi);
+
+  if (!iotjs_spi_close(spi)) {
+    return JS_CREATE_ERROR(COMMON, spi_error_str(kSpiOpClose));
   }
 
-  return jerry_create_null();
+  return jerry_create_undefined();
 }
 
-
 jerry_value_t InitSpi() {
-  jerry_value_t jspi = jerry_create_object();
-  jerry_value_t jspiConstructor =
-      jerry_create_external_function(SpiConstructor);
-  iotjs_jval_set_property_jval(jspi, IOTJS_MAGIC_STRING_SPI, jspiConstructor);
+  jerry_value_t jspi_cons = jerry_create_external_function(SpiCons);
 
   jerry_value_t prototype = jerry_create_object();
-  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_TRANSFERARRAY,
-                        TransferArray);
-  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_TRANSFERBUFFER,
-                        TransferBuffer);
   iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_CLOSE, Close);
-  iotjs_jval_set_property_jval(jspiConstructor, IOTJS_MAGIC_STRING_PROTOTYPE,
+  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_CLOSESYNC, CloseSync);
+  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_TRANSFER, Transfer);
+  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_TRANSFERSYNC,
+                        TransferSync);
+
+  iotjs_jval_set_property_jval(jspi_cons, IOTJS_MAGIC_STRING_PROTOTYPE,
                                prototype);
   jerry_release_value(prototype);
-  jerry_release_value(jspiConstructor);
 
   // SPI mode properties
   jerry_value_t jmode = jerry_create_object();
@@ -439,14 +412,14 @@ jerry_value_t InitSpi() {
   iotjs_jval_set_property_number(jmode, IOTJS_MAGIC_STRING_1, kSpiMode_1);
   iotjs_jval_set_property_number(jmode, IOTJS_MAGIC_STRING_2, kSpiMode_2);
   iotjs_jval_set_property_number(jmode, IOTJS_MAGIC_STRING_3, kSpiMode_3);
-  iotjs_jval_set_property_jval(jspi, IOTJS_MAGIC_STRING_MODE_U, jmode);
+  iotjs_jval_set_property_jval(jspi_cons, IOTJS_MAGIC_STRING_MODE_U, jmode);
   jerry_release_value(jmode);
 
   // SPI mode properties
   jerry_value_t jcs = jerry_create_object();
   iotjs_jval_set_property_number(jcs, IOTJS_MAGIC_STRING_NONE_U, kSpiCsNone);
   iotjs_jval_set_property_number(jcs, IOTJS_MAGIC_STRING_HIGH_U, kSpiCsHigh);
-  iotjs_jval_set_property_jval(jspi, IOTJS_MAGIC_STRING_CHIPSELECT_U, jcs);
+  iotjs_jval_set_property_jval(jspi_cons, IOTJS_MAGIC_STRING_CHIPSELECT_U, jcs);
   jerry_release_value(jcs);
 
   // SPI order properties
@@ -455,8 +428,9 @@ jerry_value_t InitSpi() {
                                  kSpiOrderMsb);
   iotjs_jval_set_property_number(jbit_order, IOTJS_MAGIC_STRING_LSB,
                                  kSpiOrderLsb);
-  iotjs_jval_set_property_jval(jspi, IOTJS_MAGIC_STRING_BITORDER_U, jbit_order);
+  iotjs_jval_set_property_jval(jspi_cons, IOTJS_MAGIC_STRING_BITORDER_U,
+                               jbit_order);
   jerry_release_value(jbit_order);
 
-  return jspi;
+  return jspi_cons;
 }
diff --git a/src/modules/iotjs_module_spi.h b/src/modules/iotjs_module_spi.h
index 0afe9978b..eaba4a4dc 100644
--- a/src/modules/iotjs_module_spi.h
+++ b/src/modules/iotjs_module_spi.h
@@ -32,40 +32,26 @@
 #endif
 
 typedef enum {
+  kSpiOpClose,
   kSpiOpOpen,
   kSpiOpTransferArray,
-  kSpiOpTransferBuffer,
-  kSpiOpClose,
+  kSpiOpTransferBuffer
 } SpiOp;
 
-typedef enum {
-  kSpiMode_0,
-  kSpiMode_1,
-  kSpiMode_2,
-  kSpiMode_3,
-} SpiMode;
+typedef enum { kSpiMode_0, kSpiMode_1, kSpiMode_2, kSpiMode_3 } SpiMode;
 
-typedef enum {
-  kSpiCsNone,
-  kSpiCsHigh,
-} SpiChipSelect;
+typedef enum { kSpiCsNone, kSpiCsHigh } SpiChipSelect;
 
 typedef enum { kSpiOrderMsb, kSpiOrderLsb } SpiOrder;
 
-
+// Forward declaration of platform data. These are only used by platform code.
+// Generic SPI module never dereferences platform data pointer.
+typedef struct iotjs_spi_platform_data_s iotjs_spi_platform_data_t;
+// This SPI class provides interfaces for SPI operation.
 typedef struct {
   jerry_value_t jobject;
-#if defined(__linux__)
-  iotjs_string_t device;
-  int32_t device_fd;
-#elif defined(__NUTTX__)
-  int bus;
-  uint32_t cs_chip;
-  struct spi_dev_s* spi_dev;
-#elif defined(__TIZENRT__)
-  unsigned int bus;
-  iotbus_spi_context_h hSpi;
-#endif
+  iotjs_spi_platform_data_t* platform_data;
+
   SpiMode mode;
   SpiChipSelect chip_select;
   SpiOrder bit_order;
@@ -78,44 +64,37 @@ typedef struct {
   char* tx_buf_data;
   char* rx_buf_data;
   uint8_t buf_len;
-
 } IOTJS_VALIDATED_STRUCT(iotjs_spi_t);
 
-
 typedef struct {
   bool result;
   SpiOp op;
 } iotjs_spi_reqdata_t;
 
-
 typedef struct {
   iotjs_reqwrap_t reqwrap;
   uv_work_t req;
   iotjs_spi_reqdata_t req_data;
-  iotjs_spi_t* spi_instance;
+  iotjs_spi_t* spi_data;
 } IOTJS_VALIDATED_STRUCT(iotjs_spi_reqwrap_t);
 
 
 #define THIS iotjs_spi_reqwrap_t* spi_reqwrap
-
 iotjs_spi_reqwrap_t* iotjs_spi_reqwrap_from_request(uv_work_t* req);
 iotjs_spi_reqdata_t* iotjs_spi_reqwrap_data(THIS);
-
 iotjs_spi_t* iotjs_spi_instance_from_reqwrap(THIS);
-
 #undef THIS
 
 
-#define SPI_WORKER_INIT                                                     \
-  iotjs_spi_reqwrap_t* req_wrap = iotjs_spi_reqwrap_from_request(work_req); \
-  iotjs_spi_reqdata_t* req_data = iotjs_spi_reqwrap_data(req_wrap);         \
-  iotjs_spi_t* spi = iotjs_spi_instance_from_reqwrap(req_wrap);
-
-
+jerry_value_t iotjs_spi_set_platform_config(iotjs_spi_t* spi,
+                                            const jerry_value_t jconfig);
+bool iotjs_spi_open(iotjs_spi_t* spi);
 bool iotjs_spi_transfer(iotjs_spi_t* spi);
 bool iotjs_spi_close(iotjs_spi_t* spi);
 
-void iotjs_spi_open_worker(uv_work_t* work_req);
-
+// Platform-related functions; they are implemented
+// by platform code (i.e.: linux, nuttx, tizen).
+void iotjs_spi_create_platform_data(iotjs_spi_t* spi);
+void iotjs_spi_destroy_platform_data(iotjs_spi_platform_data_t* pdata);
 
 #endif /* IOTJS_MODULE_SPI_H */
diff --git a/src/modules/linux/iotjs_module_spi-linux.c b/src/modules/linux/iotjs_module_spi-linux.c
index ab4e8be2b..239cbea1f 100644
--- a/src/modules/linux/iotjs_module_spi-linux.c
+++ b/src/modules/linux/iotjs_module_spi-linux.c
@@ -29,11 +29,37 @@
 #define ADC_DEVICE_PATH_FORMAT "/dev/spidev%d.%d"
 #define ADC_DEVICE_PATH_BUFFER_SIZE 16
 
+struct iotjs_spi_platform_data_s {
+  iotjs_string_t device;
+  int device_fd;
+};
 
-static bool iotjs_spi_set_configuration(iotjs_spi_t* spi) {
+void iotjs_spi_create_platform_data(iotjs_spi_t* spi) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+  _this->platform_data = IOTJS_ALLOC(iotjs_spi_platform_data_t);
+  _this->platform_data->device_fd = -1;
+}
+
+void iotjs_spi_destroy_platform_data(iotjs_spi_platform_data_t* pdata) {
+  iotjs_string_destroy(&pdata->device);
+  IOTJS_RELEASE(pdata);
+}
+
+jerry_value_t iotjs_spi_set_platform_config(iotjs_spi_t* spi,
+                                            const jerry_value_t jconfig) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+  iotjs_spi_platform_data_t* platform_data = _this->platform_data;
+
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, platform_data->device,
+                              IOTJS_MAGIC_STRING_DEVICE, string);
 
-  int fd = _this->device_fd;
+  return jerry_create_undefined();
+}
+
+static bool spi_set_configuration(iotjs_spi_t* spi) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+
+  int fd = _this->platform_data->device_fd;
   if (fd < 0) {
     return false;
   }
@@ -93,9 +119,9 @@ static bool iotjs_spi_set_configuration(iotjs_spi_t* spi) {
   return true;
 }
 
-
 bool iotjs_spi_transfer(iotjs_spi_t* spi) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+  iotjs_spi_platform_data_t* platform_data = _this->platform_data;
 
   struct spi_ioc_transfer data = {.tx_buf = (unsigned long)_this->tx_buf_data,
                                   .rx_buf = (unsigned long)_this->rx_buf_data,
@@ -105,7 +131,7 @@ bool iotjs_spi_transfer(iotjs_spi_t* spi) {
                                   .delay_usecs = 0 };
 
   // Transfer data
-  int err = ioctl(_this->device_fd, SPI_IOC_MESSAGE(1), &data);
+  int err = ioctl(platform_data->device_fd, SPI_IOC_MESSAGE(1), &data);
   if (err < 1) {
     DLOG("%s - transfer failed: %d", __func__, err);
     return false;
@@ -114,55 +140,54 @@ bool iotjs_spi_transfer(iotjs_spi_t* spi) {
   return true;
 }
 
-
 bool iotjs_spi_close(iotjs_spi_t* spi) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+  iotjs_spi_platform_data_t* platform_data = _this->platform_data;
 
-  if (_this->device_fd >= 0) {
+  if (platform_data->device_fd >= 0) {
     const iotjs_environment_t* env = iotjs_environment_get();
     uv_loop_t* loop = iotjs_environment_loop(env);
     uv_fs_t fs_close_req;
 
-    int err = uv_fs_close(loop, &fs_close_req, _this->device_fd, NULL);
+    int err = uv_fs_close(loop, &fs_close_req, platform_data->device_fd, NULL);
     uv_fs_req_cleanup(&fs_close_req);
     if (err < 0) {
       DLOG("%s - close failed: %d", __func__, err);
       return false;
     }
-    _this->device_fd = -1;
+    platform_data->device_fd = -1;
   }
 
   return true;
 }
 
 
-void iotjs_spi_open_worker(uv_work_t* work_req) {
-  SPI_WORKER_INIT;
+bool iotjs_spi_open(iotjs_spi_t* spi) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
+  iotjs_spi_platform_data_t* platform_data = _this->platform_data;
 
-  const char* device_path = iotjs_string_data(&_this->device);
-  if (iotjs_systemio_check_path(device_path)) {
-    // Open file
-    const iotjs_environment_t* env = iotjs_environment_get();
-    uv_loop_t* loop = iotjs_environment_loop(env);
+  const char* device_path = iotjs_string_data(&platform_data->device);
+  if (!iotjs_systemio_check_path(device_path)) {
+    return false;
+  }
 
-    uv_fs_t open_req;
-    int result = uv_fs_open(loop, &open_req, device_path, O_RDONLY, 0666, NULL);
-    uv_fs_req_cleanup(&open_req);
-    if (result < 0) {
-      req_data->result = false;
-    }
-    _this->device_fd = open_req.result;
+  // Open file
+  const iotjs_environment_t* env = iotjs_environment_get();
+  uv_loop_t* loop = iotjs_environment_loop(env);
 
-    // Set options
-    if (!iotjs_spi_set_configuration(spi)) {
-      req_data->result = false;
-      return;
-    }
-    req_data->result = true;
-  } else {
-    req_data->result = false;
+  uv_fs_t open_req;
+  int result = uv_fs_open(loop, &open_req, device_path, O_RDONLY, 0666, NULL);
+  uv_fs_req_cleanup(&open_req);
+  if (result < 0) {
+    return false;
   }
+  platform_data->device_fd = open_req.result;
+
+  // Set options
+  if (!spi_set_configuration(spi)) {
+    return false;
+  }
+  return true;
 }
 
 
diff --git a/src/modules/nuttx/iotjs_module_spi-nuttx.c b/src/modules/nuttx/iotjs_module_spi-nuttx.c
index 905ede328..8813b3586 100644
--- a/src/modules/nuttx/iotjs_module_spi-nuttx.c
+++ b/src/modules/nuttx/iotjs_module_spi-nuttx.c
@@ -22,6 +22,12 @@
 #include "modules/iotjs_module_spi.h"
 
 
+struct iotjs_spi_platform_data_s {
+  int bus;
+  uint32_t cs_chip;
+  struct spi_dev_s* spi_dev;
+};
+
 bool iotjs_spi_transfer(iotjs_spi_t* spi) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
 
diff --git a/src/modules/tizenrt/iotjs_module_spi-tizenrt.c b/src/modules/tizenrt/iotjs_module_spi-tizenrt.c
index 1a52de11f..bfce799d5 100644
--- a/src/modules/tizenrt/iotjs_module_spi-tizenrt.c
+++ b/src/modules/tizenrt/iotjs_module_spi-tizenrt.c
@@ -29,6 +29,11 @@
 #include "modules/iotjs_module_spi.h"
 
 
+struct iotjs_spi_platform_data_s {
+  unsigned int bus;
+  iotbus_spi_context_h hSpi;
+};
+
 static bool iotjs_spi_open(iotjs_spi_t* spi) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_spi_t, spi);
 
diff --git a/test/run_pass/test_spi.js b/test/run_pass/test_spi.js
index a8c6ec2f8..5a6588426 100644
--- a/test/run_pass/test_spi.js
+++ b/test/run_pass/test_spi.js
@@ -14,9 +14,7 @@
  */
 
 var assert = require('assert');
-var Spi = require('spi');
-
-var spi = new Spi();
+var spi = require('spi');
 
 var configuration = {};
 
@@ -32,8 +30,6 @@ if (process.platform === 'linux') {
 
 
 // ------ Test API existance
-assert.equal(typeof Spi, 'function',
-             'spi module does not export construction function');
 assert.assert(spi.MODE,
               'spi module does not provide \'MODE\' property');
 assert.assert(spi.CHIPSELECT,
@@ -42,12 +38,13 @@ assert.assert(spi.BITORDER,
               'spi module does not provide \'BITORDER\' property');
 assert.equal(typeof spi.open, 'function',
              'spi does not provide \'open\' function');
+assert.equal(typeof spi.openSync, 'function',
+             'spi does not provide \'openSync\' function');
 
 
 // ------ Test basic API functions
 var data = 'Hello IoTjs';
 var tx = new Buffer(data);
-var rx = new Buffer(data.length);
 
 var spi1 = spi.open(configuration, function(err) {
   assert.assert(err === null, 'spi.open failed: ' + err);
@@ -61,7 +58,7 @@ var spi1 = spi.open(configuration, function(err) {
   assert.equal(typeof spi1.closeSync, 'function',
               'spibus does not provide \'closeSync\' function');
 
-  spi1.transfer(tx, rx, function(err) {
+  spi1.transfer(tx, function(err, rx) {
     assert.assert(err === null, 'spibus.transfer failed: ' + err);
 
     spi1.close(function(err) {
@@ -74,7 +71,7 @@ var spi1 = spi.open(configuration, function(err) {
 function testSync() {
   var spi2 = spi.open(configuration, function(err) {
     assert.assert(err === null, 'spi.open for sync test failed: ' + err);
-    spi2.transferSync(tx, rx);
+    var rx = spi2.transferSync(tx);
     spi2.closeSync();
   });
 }
diff --git a/test/run_pass/test_spi_buffer.js b/test/run_pass/test_spi_buffer_async.js
similarity index 77%
rename from test/run_pass/test_spi_buffer.js
rename to test/run_pass/test_spi_buffer_async.js
index ece200894..833c9f5aa 100644
--- a/test/run_pass/test_spi_buffer.js
+++ b/test/run_pass/test_spi_buffer_async.js
@@ -14,9 +14,7 @@
  */
 
 var assert = require('assert');
-var Spi = require('spi');
-
-var spi = new Spi();
+var spi = require('spi');
 
 var configuration = {};
 
@@ -29,21 +27,13 @@ if (process.platform === 'linux') {
 }
 
 // Buffer test
-var spi1 = spi.open(configuration, function() {
+var spi1 = spi.open(configuration, function(err) {
+  assert.equal(err, null);
   var data = 'Hello IoTjs';
   var tx = new Buffer(data);
-  var rx = new Buffer(11);
-
-  this.transferSync(tx, rx);
-  var value = '';
-  for (var i = 0; i < 11; i++) {
-    value += String.fromCharCode(rx[i]);
-  }
-  console.log(value);
-  assert.equal(value, data);
 
   setTimeout(function() {
-    spi1.transfer(tx, rx, function(err) {
+    spi1.transfer(tx, function(err, rx) {
       assert.equal(err, null);
       assert.equal(rx.length, 11);
 
@@ -54,7 +44,9 @@ var spi1 = spi.open(configuration, function() {
       console.log(value);
       assert.equal(value, data);
 
-      spi1.close();
+      spi1.close(function (err) {
+        assert.equal(err, null);
+      });
     });
   }, 500);
 });
diff --git a/test/run_pass/test_spi_buffer_sync.js b/test/run_pass/test_spi_buffer_sync.js
new file mode 100644
index 000000000..14663770a
--- /dev/null
+++ b/test/run_pass/test_spi_buffer_sync.js
@@ -0,0 +1,43 @@
+/* Copyright 2016-present Samsung Electronics Co., Ltd. and other contributors
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+var assert = require('assert');
+var spi = require('spi');
+
+var configuration = {};
+
+if (process.platform === 'linux') {
+  configuration.device = '/dev/spidev0.0';
+} else if (process.platform === 'nuttx' || process.platform === 'tizenrt') {
+  configuration.bus = 1;
+} else {
+  assert.fail();
+}
+
+// Buffer test
+var spi1 = spi.openSync(configuration);
+var data = 'Hello IoTjs';
+var tx = new Buffer(data);
+
+var rx = spi1.transferSync(tx);
+assert.equal(rx.length, 11);
+var value = '';
+for (var i = 0; i < 11; i++) {
+  value += String.fromCharCode(rx[i]);
+}
+console.log(value);
+assert.equal(value, data);
+
+spi1.closeSync();
diff --git a/test/run_pass/test_spi_mcp3008.js b/test/run_pass/test_spi_mcp3008.js
index 259ea44d4..b120f3300 100644
--- a/test/run_pass/test_spi_mcp3008.js
+++ b/test/run_pass/test_spi_mcp3008.js
@@ -14,9 +14,7 @@
  */
 
 var assert = require('assert');
-var Spi = require('spi');
-
-var spi = new Spi();
+var spi = require('spi');
 
 var configuration = {};
 
@@ -33,14 +31,13 @@ var channel = 0;
 var spi0 = spi.open(configuration, function() {
   var mode = (8 + channel) << 4;
   var tx = [1, mode, 0];
-  var rx = [0, 0, 0];
 
-  spi0.transferSync(tx, rx);
+  var rx = spi0.transferSync(tx);
   console.log(((rx[1] & 0x03) << 8) + rx[2]);
 
   var loopCnt = 10;
   var loop = setInterval(function() {
-    spi0.transfer(tx, rx, function(err) {
+    spi0.transfer(tx, function(err, rx) {
       assert.equal(err, null);
       assert.equal(rx.length, 3);
 
